<?php
/**
 * GIF, JPEG, PNG
 *
 * @version 0.05 2005/06/22
 * @author Motonori Ando
 * @param $uniteimg_filename 礹ե̾ޤ
 * @param $uniteimg_direction ηh:ʿ˷, v:ľ˷硣ǥե='h'
 * @param $uniteimg_set 礭㤦·s:ɸ·, c:濴ɸ·, e:ɸ·롣ǥե='s'
 * @param $uniteimg_trans طʿƩˤ뤫ɤTRUE:Ʃ256ѥåȥ⡼ɡ, FALSE:ƩTrueColor⡼ɡˡǥե=TRUE
 * @param $uniteimg_bgcolor طʿ16ʿ6塢Red Green Blue νǻꡣǥե='000000'
 * @return ξϷΥ᡼꥽, ԤξFALSE
 */
function uniteimg($uniteimg_filename, $uniteimg_direction = 'h', $uniteimg_set = 's', $uniteimg_trans = TRUE, $uniteimg_bgcolor = '000000') {

    /************************************************************
     * 礹¸߳ǧȡϥ᡼Υ
     ************************************************************/
    $uniteimg_dst_w = 0; // Ϥ륤᡼β
    $uniteimg_dst_h = 0; // Ϥ륤᡼ν
    foreach ($uniteimg_filename as $uniteimg_key => $uniteimg_val) { // Ϥ륤᡼Υ
        if (file_exists($uniteimg_val)) { // ᡼ե뤬뤫å
            $uniteimg_src_info = getimagesize($uniteimg_val); // 
            switch ($uniteimg_direction) {
                case 'H':
                case 'h':
                    $uniteimg_dst_w += $uniteimg_src_info[0]; // û
                    if ($uniteimg_src_info[1] > $uniteimg_dst_h) {
                        $uniteimg_dst_h = $uniteimg_src_info[1]; // 
                    }
                    break;
                case 'V':
                case 'v':
                    $uniteimg_dst_h += $uniteimg_src_info[1]; // û
                    if ($uniteimg_src_info[0] > $uniteimg_dst_w) {
                        $uniteimg_dst_w = $uniteimg_src_info[0]; // 
                    }
                    break;
                default:
                    return(FALSE);
            }
        } else {
            return(FALSE);
        }
    }

    /************************************************************
     * ϥ᡼κطʤƩˤ
     ************************************************************/
    if ($uniteimg_trans) {
        $uniteimg_dst_im = @ imagecreate($uniteimg_dst_w, $uniteimg_dst_h); // ѥåȥ᡼
    } else {
        $uniteimg_dst_im = @ imagecreatetruecolor($uniteimg_dst_w, $uniteimg_dst_h); // TrueColor᡼
    }
    if (!$uniteimg_dst_im) { // ϥ᡼
        return(FALSE);
    }
    $uniteimg_color = array();
    for ($uniteimg_i = 0; $uniteimg_i < 3; $uniteimg_i++) {
        $uniteimg_color[$uniteimg_i] = hexdec(substr($uniteimg_bgcolor, $uniteimg_i * 2, 2));
    }
    $uniteimg_dst_bgcolor = imagecolorallocate($uniteimg_dst_im, $uniteimg_color[0], $uniteimg_color[1], $uniteimg_color[2]); // طʿ
    if ($uniteimg_trans) {
        $uniteimg_dst_trans = imagecolortransparent($uniteimg_dst_im, $uniteimg_dst_bgcolor); // Ʃ
        imagefill($uniteimg_dst_im, 0, 0, $uniteimg_dst_bgcolor); // ƩɤĤ֤
    }

    /************************************************************
     * ιʷ
     ************************************************************/
    $uniteimg_x1 = 0; // ԡxɸ
    $uniteimg_y1 = 0; // ԡyɸ
    foreach ($uniteimg_filename as $uniteimg_val) {
        $uniteimg_src_info = getimagesize($uniteimg_val); // 
        switch ($uniteimg_src_info[2]) { // ᡼
            case 1: // gif᡼
                $uniteimg_src_im = @ imagecreatefromgif($uniteimg_val);
                break;
            case 2: // jpeg᡼
                $uniteimg_src_im = @ imagecreatefromjpeg($uniteimg_val);
                break;
            case 3: // png᡼
                $uniteimg_src_im = @ imagecreatefrompng($uniteimg_val);
                break;
            default:
                return(FALSE);
        }
        if (!$uniteimg_src_im) { // ᡼
            return(FALSE);
        }
        switch ($uniteimg_set) {
            case 'S': // ɸ·
            case 's': // ɸ·
                switch ($uniteimg_direction) {
                    case 'H': // ʿ˷
                    case 'h': // ʿ˷
                        $uniteimg_x2 = $uniteimg_x1;
                        $uniteimg_y2 = $uniteimg_y1;
                        imagecopy($uniteimg_dst_im, $uniteimg_src_im, $uniteimg_x2, $uniteimg_y2, 0, 0, $uniteimg_src_info[0], $uniteimg_src_info[1]);
                        $uniteimg_x1 += $uniteimg_src_info[0];
                        break;
                    case 'V': // ľ˷
                    case 'v': // ľ˷
                        $uniteimg_x2 = $uniteimg_x1;
                        $uniteimg_y2 = $uniteimg_y1;
                        imagecopy($uniteimg_dst_im, $uniteimg_src_im, $uniteimg_x2, $uniteimg_y2, 0, 0, $uniteimg_src_info[0], $uniteimg_src_info[1]);
                        $uniteimg_y1 += $uniteimg_src_info[1];
                        break;
                    default:
                        return(FALSE);
                }
                break;
            case 'C': // 濴ɸ·
            case 'c': // 濴ɸ·
                switch ($uniteimg_direction) {
                    case 'H': // ʿ˷
                    case 'h': // ʿ˷
                        $uniteimg_x2 = $uniteimg_x1;
                        $uniteimg_y2 = (int)(($uniteimg_dst_h - $uniteimg_src_info[1]) / 2);
                        imagecopy($uniteimg_dst_im, $uniteimg_src_im, $uniteimg_x2, $uniteimg_y2, 0, 0, $uniteimg_src_info[0], $uniteimg_src_info[1]);
                        $uniteimg_x1 += $uniteimg_src_info[0];
                        break;
                    case 'V': // ľ˷
                    case 'v': // ľ˷
                        $uniteimg_x2 = (int)(($uniteimg_dst_w - $uniteimg_src_info[0]) / 2);
                        $uniteimg_y2 = $uniteimg_y1;
                        imagecopy($uniteimg_dst_im, $uniteimg_src_im, $uniteimg_x2, $uniteimg_y2, 0, 0, $uniteimg_src_info[0], $uniteimg_src_info[1]);
                        $uniteimg_y1 += $uniteimg_src_info[1];
                        break;
                    default:
                        return(FALSE);
                }
                break;
            case 'E': // ɸ·
            case 'e': // ɸ·
                switch ($uniteimg_direction) {
                    case 'H': // ʿ˷
                    case 'h': // ʿ˷
                        $uniteimg_x2 = $uniteimg_x1;
                        $uniteimg_y2 = $uniteimg_dst_h - $uniteimg_src_info[1];
                        imagecopy($uniteimg_dst_im, $uniteimg_src_im, $uniteimg_x2, $uniteimg_y2, 0, 0, $uniteimg_src_info[0], $uniteimg_src_info[1]);
                        $uniteimg_x1 += $uniteimg_src_info[0];
                        break;
                    case 'V': // ľ˷
                    case 'v': // ľ˷
                        $uniteimg_x2 = $uniteimg_dst_w - $uniteimg_src_info[0];
                        $uniteimg_y2 = $uniteimg_y1;
                        imagecopy($uniteimg_dst_im, $uniteimg_src_im, $uniteimg_x2, $uniteimg_y2, 0, 0, $uniteimg_src_info[0], $uniteimg_src_info[1]);
                        $uniteimg_y1 += $uniteimg_src_info[1];
                        break;
                    default:
                        return(FALSE);
                }
                break;
            default:
                return(FALSE);
        }
    }
    imagedestroy($uniteimg_src_im); // ᡼˴

    return($uniteimg_dst_im); // ϥ᡼ƽФϤƽλ
}
?>